﻿using System.Web.Mvc;
using Kreta.BusinessLogic.Interfaces;
using Kreta.BusinessLogic.Security;
using Kreta.Core;
using Kreta.Core.Iktato.Poszeidon.Factory.Interface;
using Kreta.Web.Areas.Intezmeny.ApiControllers;
using Kreta.Web.Areas.Intezmeny.Models;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.Intezmeny.Controllers
{
    [MvcRoleClaimsAuthorize(true)]
    [MvcRolePackageDenyAuthorize(KretaClaimPackages.IsOnlyAlkalmozott.ClaimValue)]
    [MvcRolePackageAuthorize(KretaClaimPackages.Ellenorzo.ClaimValue)]
    public class InformaciokIntezmenyController : Controller
    {
        private IIktatoRepositoryFactory IktatoRepositoryFactory { get; }
        private IktatoServiceConfiguration IktatoServiceConfiguration { get; }
        private readonly IJiraHelper JiraHelper;

        public InformaciokIntezmenyController(IJiraHelper jiraHelper, IIktatoRepositoryFactory iktatoRepositoryFactory, IktatoServiceConfiguration iktatoServiceConfiguration)
        {
            IktatoRepositoryFactory = iktatoRepositoryFactory;
            IktatoServiceConfiguration = iktatoServiceConfiguration;
            JiraHelper = jiraHelper;
        }

        // GET: Intezmeny/InformaciokIntezmeny
        public ActionResult Index()
        {
            var api = new IntezmenyApiController(JiraHelper);
            IntezmenyModel model = api.GetIntezmeny(IktatoRepositoryFactory, IktatoServiceConfiguration);

            return View(model);
        }
    }
}
